#ifndef PW_SYSTEM_WINDOW_HPP
#define PW_SYSTEM_WINDOW_HPP

#include <pw/core/globals.hpp>
#include <pw/core/size.hpp>

namespace pw {

class window {
public:

    window();
    ~window();

    bool update();

	void set_title(const std::string& title);

    void set_size(int w, int h);
    size get_size() const;

    typedef void drop_callback;


protected:

	struct impl;
	std::unique_ptr<impl> _impl;

};

}

#endif
